
procedure dual_bresenham(top_left_x,top_left_y,bot_left_x,bot_left_y,
                                         top_rt_x,top_rt_y,bot_rt_x,bot_rt_y : integer);
{ cranks out 2 lines in parallel, then fills the space between them }
var
  left_d,left_dx,left_ai,left_bi,left_xi,left_x,y,dy,yi,j : integer;
  rt_d,rt_dx,rt_ai,rt_bi,rt_xi,rt_x : integer;
  left_lasty,rt_lasty,save_y : integer;
begin
  if (top_left_y <> top_rt_y) or (bot_left_y <> bot_rt_y) then
        writeln(output,' Y coord mismatch in dual bresenham.')
  else begin
   if (top_left_y = bot_left_y) then begin
      { only one line to process }
      rasfill_line(top_left_x,top_rt_x,top_left_y);
   end else begin
    {$ifdef bresen}
    writeln(output,'Bresenham ',top_left_x:5,top_left_y:5,
          bot_left_x:5,bot_left_y:5);
    writeln(output,'          ',top_rt_x:5,top_rt_y:5,bot_rt_x:5,
          bot_rt_y:5);
    {$endif}
    left_x := top_left_x;
    rt_x := top_rt_x;
    y := top_left_y;
    if (top_left_x < bot_left_x) then begin
      left_xi :=  1;
      left_dx := bot_left_x - top_left_x;
    end else begin
      left_xi :=  -1;
      left_dx := top_left_x - bot_left_x;
    end;
    if (top_rt_x < bot_rt_x) then begin
      rt_xi :=  1;
      rt_dx := bot_rt_x - top_rt_x;
    end else begin
      rt_xi :=  -1;
      rt_dx := top_rt_x - bot_rt_x;
    end;
    if top_left_y < bot_left_y then begin
      yi := 1;
      dy := bot_left_y - top_left_y;
    end else begin
      yi := -1;
      dy := top_left_y - bot_left_y;
    end;
    {$ifdef bresen}
    writeln(output,'bresenham first rasfill ',left_x:6,rt_x:6,y:6);
    {$endif}
    rasfill_line(left_x,rt_x,y);    { the initial dots }
    if left_dx > dy then begin
      left_ai := (dy - left_dx ) * 2;
      left_bi := dy * 2;
      left_d  := left_bi - left_dx;
    end else begin
      left_ai := (left_dx - dy ) * 2;
      left_bi := left_dx * 2;
      left_d  := left_bi - dy;
    end;
    if rt_dx > dy then begin
      rt_ai := (dy - rt_dx) * 2;
      rt_bi := dy * 2;
      rt_d  := rt_bi - rt_dx;
    end else begin
      rt_ai := (rt_dx - dy ) * 2;
      rt_bi := rt_dx * 2;
      rt_d  := rt_bi - dy;
    end;
    left_lasty := y;
    rt_lasty := y;
    repeat
      save_y := y;
      repeat
        if left_dx > dy then begin
          if (left_d >= 0) then begin
            inc(y,yi);
            inc(left_d,left_ai);
          end else begin
            inc(left_d,left_bi);
          end;
          inc(left_x,left_xi);
        end else begin
          if (left_d >= 0) then begin
            inc(left_x,left_xi);
            inc(left_d,left_ai);
          end else begin
            inc(left_d,left_bi);
          end;
          inc(y,yi);
        end;
      until y <> left_lasty;
      left_lasty := y;
      y := save_y;
      repeat
        if rt_dx > dy then begin
          if (rt_d >= 0) then begin
            inc(y,yi);
            inc(rt_d,rt_ai);
          end else begin
            inc(rt_d,rt_bi);
          end;
          inc(rt_x,rt_xi);
        end else begin
          if (rt_d >= 0) then begin
            inc(rt_x,rt_xi);
            inc(rt_d,rt_ai);
          end else begin
            inc(rt_d,rt_bi);
          end;
          inc(y,yi);
        end;
      until y <> rt_lasty;
      rt_lasty := y;
      {$ifdef bresen}
      writeln(output,'bresenham calls rasfill ',left_x:6,rt_x:6,y:6);
      {$endif}
      rasfill_line(left_x,rt_x,y);
    until (y = bot_left_y);
   end;
  end;
end;

procedure draw_line(a_line : line_ptr_type ; draw_window : window);
{ evaluates appropriate aperture, then draws clipped segment
            of line (in that width) to appropriate raster
            band buffer }
{ procedure draw_trace(atrace : trace_ptr; a_window : window);}
var
    x1,x2,y1,y2 : integer;
    antiangle : real;
    wstep,side,nx1,ny1,nx2,ny2 : integer;
    poly_x,poly_y : poly_array;
    ix,iy,ix1,iy1,ix2,iy2,a     : integer;
    cangle,sangle : real;
    draw_xmin,draw_xmax,draw_ymin,draw_ymax : integer;
    trit_top_y,trit_bot_y,trit_lt_x,trit_rt_x : integer;
    trib_top_y,trib_bot_y,trib_lt_x,trib_rt_x : integer;
    sort_flag : boolean;
    i : integer;
    bp : band_ptr_type;
begin
    with draw_window do begin
        x1:=a_line^.x1 - x_offset; y1:=a_line^.y1;
        x2:=a_line^.x2 - x_offset; y2:=a_line^.y2;
    end;        {with}
 {   if clipln(x1,y1,x2,y2,draw_window) then begin}
    {$ifdef line_dump}
    writeln(output,'draw_line ',x1:6,y1:6,'  ',x2:6,y2:6);
    {$endif}
{ draw flashes at the endpoints to round end of trace }
        bit_blt_or(a_line^.x1,y1,a_line^.this_apt);
        bit_blt_or(a_line^.x2,y2,a_line^.this_apt);
    {if line is entirely outside window, assume 2d trace is too}
    {find 1/slope}
        if y1=y2 then antiangle:=arctan(10000.0) {prevent div by 0 fault}
        else  antiangle:=-arctan((x1-x2)/(y1-y2));
        {$ifdef line_dump}
        writeln(output,'antiangle ',antiangle);
        {$endif}
        cangle := cos(antiangle);
        sangle := sin(antiangle);
        wstep:=round(a_line^.width/2.0);
        side:=-wstep;
        poly_x[1]:=round(x1+side*cangle);
        poly_y[1]:=round(y1+side*sangle);
        poly_x[4]:=round(x2+side*cangle);
        poly_y[4]:=round(y2+side*sangle);
        side:=wstep;
        poly_x[2]:=round(x1+side*cangle);
        poly_y[2]:=round(y1+side*sangle);
        poly_x[3]:=round(x2+side*cangle);
        poly_y[3]:=round(y2+side*sangle);
 { sort 4 poly vertices in order of descending Y coords }
        repeat
          sort_flag := false;
          for i := 1 to 3 do
            if poly_y[i] < poly_y[i+1] then begin
              a := poly_y[i+1];
              poly_y[i+1] := poly_y[i];
              poly_y[i] := a;
              a := poly_x[i+1];
              poly_x[i+1] := poly_x[i];
              poly_x[i] := a;
              sort_flag := true;
            end;                        { if }
        until not sort_flag;
        draw_ymax := poly_y[1];
        draw_ymin := poly_y[4];
        draw_xmin :=  10000;
        draw_xmax := -10000;
        for i := 1 to 4 do begin
          if poly_x[i] > draw_xmax then draw_xmax := poly_x[i];
          if poly_x[i] < draw_xmin then draw_xmin := poly_x[i];
        end;
{ now fill area enclosed by poly_x, poly_y arrays }
  { convert plot space edges to band space edges }
        draw_ymin := draw_ymin - band_yoffset;
        draw_ymax := draw_ymax - band_yoffset;
        {$ifdef line_dump }
        writeln(output,'draw shifted',draw_xmin:6,draw_ymin:6,'   ',
            draw_xmax:6,draw_ymax:6);
        writeln(output,'window_ymin,ymax ',draw_window.ymin:6,
            draw_window.ymax:6);
        writeln(output,'check xy ',x1:6,y1:6,'  ',x2:6,y2:6);
        {$endif}
  { window first to see if any part could be in band }
        if (draw_ymin <= band_width-1) and (draw_ymax  >= 0) then begin
          if draw_ymin < 0 then draw_ymin := 0;
          if draw_ymax > band_width -1 then draw_ymax := band_width-1;
          if (x1 = x2) or (y1 = y2) then begin  { aligned horiz or vert line }
            {$ifdef line_dump }
            writeln(output,'drawing line, x1,y1,x2,y2 ',
                draw_xmin:6,draw_ymin:6,'    ',draw_xmax:6,draw_ymax:6);
            {$endif}
            if draw_xmin < 0 then draw_xmin := 0;  { protect array bounds }
            if draw_xmax > line_length-1 then draw_xmax := line_length-1;
            for i := draw_ymin to draw_ymax do begin
              if which_band = 1 then
                bp := band1_array[i]
              else
                bp := band2_array[i];
              if pos_neg = positive then
                for j := draw_xmin to draw_xmax do
                    bp^[J] := bp^[J] or 1
              else
                for j := draw_xmin to draw_xmax do
                    bp^[J] := bp^[J] and not (1);
            end;			{ for i := }
        end else begin  { a line with 0 < slope < infinity}
{***** now have to fill area as 3 pieces, a triangle at top,a parallelogram,
                and a triangle at bottom }
          {Poly[1] is at top, but we have to find whether poly[2] or poly[3] is left }
          if poly_x[2] < poly_x[1] then begin           { poly[2] is left side }
  { left line segment is complete, but we have to find intercept on right line seg
          {             that has same Y coord as poly_y[2]      }
            trit_top_y := poly_y[1];
            trit_bot_y := poly_y[2];
            trit_lt_x := poly_x[2];
            trit_rt_x := intercept(poly_x[1],poly_y[1],poly_x[3],poly_y[3],poly_y[2]);
            dual_bresenham(poly_x[1],poly_y[1],trit_lt_x,trit_bot_y,
                        poly_x[1],poly_y[1],trit_rt_x,trit_bot_y);
          { now we need to find intercept on left seg across from poly_y[3] }
            trib_top_y := poly_y[3];
            trib_bot_y := poly_y[4];
            trib_rt_x := poly_x[3];
            trib_lt_x := intercept(poly_x[2],poly_y[2],poly_x[4],poly_y[4],poly_y[3]);
            dual_bresenham(trib_lt_x,trib_top_y,poly_x[4],poly_y[4],
                        trib_rt_x,trib_top_y,poly_x[4],poly_y[4]);
          { finally, fill in center parallelogram part }            
            dual_bresenham(poly_x[2],poly_y[2],trib_lt_x,trib_top_y,
                                     trit_rt_x,trit_bot_y,poly_x[3],poly_y[3]);
          end else begin
   { right line segment is complete, but we have to find intercept on left line seg
          {             that has same Y coord as poly_y[2]      }
            trit_top_y := poly_y[1];
            trit_bot_y := poly_y[2];
            trit_rt_x := poly_x[2];
            trit_lt_x := intercept(poly_x[1],poly_y[1],poly_x[3],poly_y[3],poly_y[2]);
            dual_bresenham(poly_x[1],poly_y[1],trit_lt_x,trit_bot_y,
                        poly_x[1],poly_y[1],trit_rt_x,trit_bot_y);
          { now we need to find intercept on right seg across from poly_y[3] }
            trib_top_y := poly_y[3];
            trib_bot_y := poly_y[4];
            trib_lt_x := poly_x[3];
            trib_rt_x := intercept(poly_x[2],poly_y[2],poly_x[4],poly_y[4],poly_y[3]);
            dual_bresenham(trib_lt_x,trib_top_y,poly_x[4],poly_y[4],
                        trib_rt_x,trib_top_y,poly_x[4],poly_y[4]);
          { finally, fill in center parallelogram part }            
            dual_bresenham(trit_lt_x,trit_bot_y,poly_x[3],poly_y[3],
                                     poly_x[2],poly_y[2],trib_rt_x,trib_top_y);
          end;          { if poly_x[2] < }
        end;            { if (x1 = x2... }
      end;              { if draw_ymin }
 {   end;                {if clipln...}
end;                    {proc draw_line}

