program photoplt(input,output,infile);
{$R photoplt.res}
 {$define verbose}

uses photogbl,photoman,photodrv,Strings,WinTypes,WinProcs,
     WinDos,WObjects,StdDlgs,WinCrt;

{$I photodef.pas}

const
  { declare resource IDs }
  cm_Aperture    = 102;
  cm_Gerber   = 103;
  cm_Plot   = 105;
  cm_Options = 154;
  cm_Help   = 901;
  file_name_len = 40;
  id_negative = 201;
  id_mirror = 202;
  id_scale = 203;
  id_ap_ST1 = 309;
  id_tell_apertures = 310;
  id_GrbLines = 170;
  id_PltDimX  = 171;
  id_PltDimY  = 172;
  id_PltFlash = 173;
  id_PltDCP   = 174;
  id_PltDCV   = 175;
  id_PltDCH   = 176;
  id_PltDCD   = 177;
  id_PltRev   = 178;
  id_BandWidth= 179;
  id_WriteText = 193;

  staticStringSize = 40;
  
Type
  string_ch_type = string[StaticStringSize];        { a bit of nastiness to be able to }
  TextChars = array [0..StaticStringSize] of char; { use SetText }

{types for windows interface }
type
tmyapplication = object(tapplication)
  procedure initmainwindow; virtual;
end;

type
  pmywindow = ^tmywindow;
  tmywindow = object(twindow)
        DragDC: HDC;
    ButtonDown: Boolean;
    ThePen: HPen;
    PenSize: Integer;
    Points: PCollection;
    FileName: array[0..fsPathName] of Char;
    Negative1, Mirror1,Scale : PCheckBox;
    Aper_Stat,TextStat,GerberLinesStat,PltDimXStat,PltDimYStat : PStatic;
    PltFlashStat,PltDCPStat,PltDCVStat,PltDCHStat,PltDCDStat   : PStatic;
    PltRevStat,BandWidthStat : PStatic;
    Group1: PGroupBox;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    destructor Done; virtual;
    function canclose : boolean; virtual;
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
      virtual {wm_first + cm_Open};
    procedure AptFileOpen(var Msg: TMessage);
      virtual cm_First + cm_Aperture;
    procedure GrbFileOpen(var Msg: TMessage);
      virtual cm_First + cm_Gerber;
    procedure Plot(var Msg: TMessage);
      virtual cm_First + cm_Plot;
    procedure Options(var Msg: TMessage);
      virtual cm_First + cm_Options;
    procedure Help(var Msg: TMessage);
      virtual cm_First + cm_Help;
    procedure HandleNegativeMsg(var Msg: TMessage);
      virtual id_First + id_Negative;
    procedure HandleMirrorMsg(var Msg: TMessage);
      virtual id_First + id_Mirror;
    procedure HandleScaleMsg(var Msg: TMessage);
      virtual id_First + id_Scale;
    procedure tell_apertures(var Msg: String_ch_type);
      virtual id_First + id_tell_apertures;
    Procedure GerberLines(var Msg: String_ch_type);
      virtual id_First + id_GrbLines;
    Procedure PltDimX(var Msg: String_ch_type);
      virtual id_First + id_PltDimX;
    Procedure PltDimY(var Msg: String_ch_type);
      virtual id_First + id_PltDimY;
    Procedure PltFlash(var Msg: String_ch_type);
      virtual id_First + id_PltFlash;
    Procedure PltDCP(var Msg: String_ch_type);
      virtual id_First + id_PltDCP;
    Procedure PltDCV(var Msg: String_ch_type);
      virtual id_First + id_PltDCV;
    Procedure PltDCH(var Msg: String_ch_type);
      virtual id_First + id_PltDCH;
    Procedure PltDCD(var Msg: String_ch_type);
      virtual id_First + id_PltDCD;
    Procedure PltRev(var Msg: String_ch_type);
      virtual id_First + id_PltRev;
    Procedure BandWidth(var Msg: String_ch_type);
      virtual id_First + id_BandWidth;
    procedure WriteText(var Msg: String_ch_type; X,Y : word);
      virtual id_First + id_WriteText;    
end;

type
  PDPoint = ^TDPoint;
  TDPoint = object(TObject)
    X, Y: Integer;
    constructor Init(AX, AY: Integer);
  end;

{--------------------------------------------------}
{ TMyWindow's method implementations:              }
{--------------------------------------------------}

constructor TMyWindow.Init(AParent: PWindowsObject; ATitle: PChar);
var
{  aper_stat : PStatic;  }
  Aper_text : textChars;
  x,y,len : word;
begin
  TWindow.Init(AParent, ATitle);
  Attr.Menu := LoadMenu(HInstance, PChar(100));
  ButtonDown := False;
  PenSize := 1;
  ThePen := CreatePen(ps_Solid, PenSize, 0);
  Points := New(PCollection, Init(50, 50));
  Negative1 := New(PCheckBox, Init(@Self, id_Negative, 'Negative',
    100, 12, 150, 26, nil));
  Mirror1 := New(PCheckBox, Init(@Self, id_Mirror, 'Mirror',
    100, 50, 150, 26, nil));
  Scale := New(PCheckBox, Init(@Self, id_Scale, 'Scale',
    100, 75, 150, 26, nil));
  Aper_Stat := New(PStatic,Init(@Self,id_tell_apertures,'no Apertures',20,120,
        250,25,39));
  TextStat := New(PStatic,Init(@Self,id_WriteText,' ',450,100,250,25,39));
  GerberLinesStat := New(PStatic,Init(@Self,id_GrbLines,'No Gerber Lines Read',
        20,150,250,26,39));
  PltDimXStat := New(PStatic,Init(@Self,id_PltDimX,'Plot Size X',
        20,180,350,26,39));
  PltDimYStat := New(PStatic,Init(@Self,id_PltDimY,'Plot Size Y',
        20,210,350,26,39));
  PltFlashStat := New(PStatic,Init(@Self,id_PltFlash,'Flashes',
        20,240,250,26,39));
  PltDCPStat := New(PStatic,Init(@Self,id_PltDCP,'Points',
        20,270,350,26,39));
  PltDCVStat := New(PStatic,Init(@Self,id_PltDCV,'Vertical Lines',
        20,300,250,26,39));
  PltDCHStat := New(PStatic,Init(@Self,id_PltDCH,'Horizontal Lines',
        20,330,250,26,39));
  PltDCDStat := New(PStatic,Init(@Self,id_PltDCD,'Diagonal Lines',
        20,360,350,26,39));
  PltRevStat := New(PStatic,Init(@Self,id_PltRev,'Plot Revolutions',
        20,390,250,26,39));
  BandWidthStat := New(PStatic,Init(@Self,id_BandWidth,'Rasterizing Band',
        20,420,250,26,39));
end;

destructor TMyWindow.Done;
begin
  Dispose(Points, Done);
  DeleteObject(ThePen);
  TWindow.Done;
end;

type
  line_type = ^line;

line = record
  x_start,x_end,y : integer;
  next_line : line_type;
end;

var
  infile,picture : text;
  head,tail,point : line_type;
  achar : char;


{ windows routines }
function tmywindow.canclose : boolean;
var
  reply : integer;
begin
  canclose := true;
{  reply := messagebox(hwindow,' save ?',' changed ',
    mb_yesno or mb_iconquestion);
  if reply = id_yes then canclose := false;}
end;

{--------------------------------------------------}
{ TDPoints's method implementations:               }
{--------------------------------------------------}

constructor TDPoint.Init(AX, AY: Integer);
begin
  X := AX;
  Y := AY;
end;


procedure tmyapplication.initmainwindow;
begin
  mainwindow := new(pmywindow, init(nil,'PhotoPlotter'));
end;

procedure DrawLine(paintdc: HDC; P: line_type); far;
begin
  MoveTo(PaintDC, P^.X_start, P^.Y);
  LineTo(PaintDC, P^.X_end, P^.Y);
end;

procedure TMyWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
begin
  point := head;
  while point <> nil do begin
    DrawLine(paintdc,point);
    point := point^.next_line;
  end;
end;

procedure TMyWindow.AptFileOpen(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
  aper_text : string_ch_type;
begin
  if canclose then
    if application^.execdialog(new(pfiledialog,init(@self,
      pchar(sd_fileopen),strcopy(filename,'*.apl')))) = id_ok then begin
    {$ifdef verbose}
    writeln(output,'opening aperture file');
    {$endif}
    assign (infile,filename);
    reset(infile);
    lines := read_aperture(infile);
    str(lines,aper_text);
    aper_text := aper_text+' Apertures read in.';
  { SendMessage(TMyWindow^.HWindow,id_tell_apertures,1,2);}
    TMyWindow.Tell_Apertures(aper_text);   
    apertures_loaded := true;
    invalidaterect(hwindow,nil,true);
  end;                  { if application }
end;		{ proc tmywindow.aptfileopen }

procedure TMyWindow.GrbFileOpen(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
  AStat : PStatic;
  Atext,Btext,Ctext : string_ch_type;
  WText : TextChars;
  pstring : ^TextChars;
begin
  if apertures_loaded then
    if application^.execdialog(new(pfiledialog,init(@self,
      pchar(sd_fileopen),strcopy(filename,'*.top')))) = id_ok then begin
  assign (infile,filename);
  reset(infile);
  lines := read_gerber(infile);
{  writeln(output,lines,' Gerber command lines read in.');   }
    str(lines,atext);
    btext := atext+' Gerber Lines read in.';
    TMyWindow.GerberLines(btext);   

  Gerber_loaded := true;
      with main_window do begin
{        writeln(output,' Plot Dimensions (without border)');
        writeln(output,' X Min = ',xmin,'      X Max = ',xmax);
        writeln(output,' Y Min = ',ymin,'      Y Max = ',ymax);}
        str(xmin,atext);
        str(xmax,btext);
        ctext := 'X Min = ' + atext + ' X max = ' + btext;
        TMyWindow.PltDimX(ctext);
        str(ymin,atext);
        str(ymax,btext);
        ctext := 'Y Min = ' + atext + ' Y max = ' + btext;
        TMyWindow.PltDimY(ctext);
      end;                                      { with }
      define_bands;
      str(flash_count,atext);
      btext := atext +'  flashes in plot file.';
      TMyWindow.PltFlash(btext);

 {     TMyWindow.WriteText(atext,450,40);}
{      AStat := New(Pstatic,Init(@Self, id_st1,pstring^,450,40,150,24,20));}   
{      AStat := New(Pstatic,Init(@TMyWindow, id_st1,' ap loaded ',450,40,150,24,0));}
      str(draw_count_point,atext);
      btext := atext +' Degenerate point draws,';
      TMyWindow.PltDCP(btext);
      str(draw_count_vert,atext);
      btext := atext +' Vertical draws,';
      TMyWindow.PltDCV(btext);
      str(draw_count_Horiz,atext);
      btext := atext +' Horizontal draws,';
      TMyWindow.PltDCH(btext);
      str(draw_count_diag,atext);
      btext := atext +' Diagonal draws in plot file.';
      TMyWindow.PltDCd(btext);

{      writeln(output,draw_count_point,' degenerate point draws,');
      writeln(output,draw_count_vert,'  vertical   draws,');
      writeln(output,draw_count_horiz,'  horizontal draws,');
      writeln(output,draw_count_diag,'  diagonal   draws in plot file.'); }
      if mirror then begin
        writeln(output,' Reversing X axis ');
        x_delta := main_window.xmax - main_window.xmin;
        x_refl := 2 * main_window.xmin;
        flash_1 := flash_head;          { reverse all flashes }
        while flash_1 <> nil do begin
          flash_1^.x := x_delta - flash_1^.x + x_refl;
          flash_1 := flash_1^.next_flash;
        end;
        writeln(output,'all flashes reversed, now doing draws.');
        draw_1 := line_head;            { draw all draws }
        while draw_1 <> nil do begin
          draw_1^.x1 := x_delta - draw_1^.x1 + x_refl;
          draw_1^.x2 := x_delta - draw_1^.x2 + x_refl;
          draw_1 := draw_1^.next_line;
        end;
      end;
      if num_beams = 1 then
          str(main_window.ymax+border+border,atext)
      else
          str((main_window.ymax+border+border) div num_beams,atext);
      btext := 'Plot will take ' + atext + ' rotations.';
      TMyWindow.PltRev(btext);
      str(lines_band,atext);
      btext := 'Rasterizing Band is ' + atext + ' lines.';
      TMyWindow.BandWidth(btext);

   {$ifdef dump_band_pointers}
     for i := 0 to lines_band-1 do begin
      writeln(output,'band1_array[',i,'] => ',seg(band1_array[i]^),
             ':',ofs(band1_array[i]^));
      writeln(output,'band2_array[',i,'] => ',seg(band2_array[i]^),
             ':',ofs(band2_array[i]^));
     end;
        {$endif}
     {$ifdef verbose}
      writeln(output,'waiting for you to read this.');
        readln(input);     { delay to read screen }
        flash_1 := flash_head;          { list all flashes }
        repeat
          writeln(output,'Flash ',flash_1^.x:7,flash_1^.y:7,
                flash_1^.this_apt^.x_size:5);
          flash_1 := flash_1^.next_flash;
        until (flash_1 = nil);
        draw_1 := line_head;            { list all draws }
        repeat
          writeln(output,'Draw',draw_1^.x1:7,draw_1^.y1:7,
            draw_1^.x2:7,draw_1^.y2:7,draw_1^.width:5);
          draw_1 := draw_1^.next_line;
        until (draw_1 = nil);
     {$endif}

    invalidaterect(hwindow,nil,true);
  end                  { if apertures_loaded }
  else
    MessageBox(HWindow, 'You must load Apertures first!',
           'Help', mb_Ok)
end;		{ proc tmywindow.Grbfileopen }
 
procedure TMyWindow.Plot(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
begin
  if canclose then
    if (apertures_loaded and gerber_loaded) then
      make_plot
    else
      if not apertures_loaded then
        MessageBox(HWindow, 'You must load Apertures first!',
           'Help', mb_Ok)
      else
        MessageBox(HWindow, 'You must load Gerber data first!',
           'Help', mb_Ok);
end;

procedure TMyWindow.HandleNegativeMsg(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
begin
  if (negative1^.GetCheck = 0) then
    pos_neg := positive
  else
    pos_neg := negative;
end;

procedure TMyWindow.Tell_Apertures(var Msg: string_ch_type);
var
  i : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  for i := 1 to length(Msg) do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize do
    char_msg[i] := ' ';
  Aper_Stat^.SetText(char_msg);
end;

procedure TMyWindow.GerberLines(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  GerberLinesStat^.SetText(char_msg);
end;

procedure TMyWindow.PltDimX(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltDimXStat^.SetText(char_msg);
end;

procedure TMyWindow.PltDimY(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltDimYStat^.SetText(char_msg);
end;

procedure TMyWindow.PltFlash(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltFlashStat^.SetText(char_msg);
end;

procedure TMyWindow.PltDCP(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltDCPStat^.SetText(char_msg);
end;

procedure TMyWindow.PltDCV(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltDCVStat^.SetText(char_msg);
end;

procedure TMyWindow.PltDCH(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltDCHStat^.SetText(char_msg);
end;

procedure TMyWindow.PltDCD(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltDCDStat^.SetText(char_msg);
end;

procedure TMyWindow.PltRev(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  PltRevStat^.SetText(char_msg);
end;

procedure TMyWindow.BandWidth(var Msg: string_ch_type);
var
  i,j : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  if length(Msg) >= StaticStringSize then
    j := StaticStringSize-1
  else
    j := length(Msg);
  for i := 1 to j do
    char_msg[i-1] := Msg[i];
  for i := i to StaticStringSize-1 do
    char_msg[i] := chr(0);
  BandWidthStat^.SetText(char_msg);
end;

procedure TMyWindow.WriteText(var Msg: string_ch_type; X,Y : word);
var
  i,len : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
begin
  len := length(Msg);
  if len > 29 then len := 29;
  for i := 1 to len do
    char_msg[i-1] := Msg[i];
  for i := i to 30 do
    char_msg[i] := ' ';
  TextStat^.SetText(char_msg);
  {^.PStatic,Init(@Self,id_WriteText,char_msg,X,Y+50,
        250,25,0);  } 
 { TextStat^.Init(@Self,id_WriteText,'abcde',100,200,
        250,25,0);  }
end;  

{procedure TMyWindow.WRTTXT(PaintDC: HDC; var Msg: string_ch_type; X,Y : word);
var
  i,len : integer;
  pen : boolean;
  char_msg : TextChars;         { HORRORS }
{begin
  len := length(Msg);
  if len > 29 then len := 29;
  for i := 1 to len do
    char_msg[i-1] := Msg[i];
  for i := i to 30 do
    char_msg[i] := ' ';
  Height := DrawText(PaintDC,  char_msg,len,trect,format);
end;   }

procedure TMyWindow.HandleMirrorMsg(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
begin
  if (mirror1^.GetCheck = 0) then
    mirror := false
  else
    mirror := true;
end;

procedure TMyWindow.HandleScaleMsg(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
begin
  if (scale^.GetCheck = 0) then
    curr_window.scale := 1
  else
    curr_window.scale := 2;
end;

procedure TMyWindow.Options(var Msg: TMessage);
var
  i,j,x_start,x_end,y : integer;
  pen : boolean;
begin
  if canclose then
end;

procedure TMyWindow.Help(var Msg: TMessage);
begin
  MessageBox(HWindow, 'Feature not implemented', 'Help', mb_Ok);
end;


var
  MyApp : TMyApplication;
begin                           { main }
  init;
  myapp.init('PhotoPlt');
  loadmenu(hinstance,'SAMPLE_MENU');
  myapp.run;
  stop_motors;
  myapp.done;
end.